/**************************************************************************
* Copyright 2019 Pascal Gloor
* 
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
* 
*     http://www.apache.org/licenses/LICENSE-2.0
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
**************************************************************************/

#ifndef __DP_ACCOUNTING
#define __DP_ACCOUNTING 1

#include <uthash.h>

#include "dp_helpers.h"

#define DP_AC_CLEAN_INT 5

typedef struct dp_accounting {
	unsigned char remoteid[256];
	int len;
	int count;
	UT_hash_handle hh;
} dp_accounting;


void       dp_accounting_add   (dp_conf*, unsigned char *, int);
int        dp_accounting_check (dp_conf*, unsigned char *, int);
void       dp_accounting_cleanup     (dp_conf*);

#endif // __DP_MACRO
