/**************************************************************************
* Copyright 2019 Pascal Gloor
* 
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
* 
*     http://www.apache.org/licenses/LICENSE-2.0
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
**************************************************************************/

#ifndef __DP_BLACKLIST
#define __DP_BLACKLIST 1

#include <uthash.h>

#include "dp_helpers.h"

#define DP_BL_CLEAN_INT 5

typedef struct dp_blacklist {
	unsigned char remoteid[256];
	int len;
	time_t expire;
	UT_hash_handle hh;
} dp_blacklist;

dp_blacklist *dp_blacklist_get(void);
void       dp_blacklist_add    (dp_conf*, unsigned char *, int);
int        dp_blacklist_check  (dp_conf*, unsigned char *, int);
void       dp_blacklist_cleanup     (dp_conf*);

#endif // __DP_MACRO
