/**************************************************************************
* Copyright 2019 Pascal Gloor
* 
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
* 
*     http://www.apache.org/licenses/LICENSE-2.0
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
**************************************************************************/

#ifndef __DP_DHCPV4
#define __DP_DHCPV4 1

#include "dp_helpers.h"

static char *dp_dhcpv4_code[] = {
	NULL,
	"DISCOVER",
	"OFFER",
	"REQUEST",
	"DECLINE",
	"ACK",
	"NAK",
	"RELEASE",
	"INFORM",
	"FORCERENEW",
	"LEASEQUERY",
	"LEASEUNASSIGNED",
	"LEASEUNKNOWN",
	"LEASEACTIVE",
	"BULKLEASEQUERY",
	"LEASEQUERYDONE",
	"ACTIVELEASEQUERY"
	"LEASEQUERYSTATUS",
	"TLS"
};

#define DP_DHCPV4_CODE_LEN (sizeof(dp_dhcpv4_code)/sizeof(dp_dhcpv4_code[0]))

typedef struct dp_dhcpv4_stats {
	long long unsigned int relcnt[DP_DHCPV4_CODE_LEN];
	long long unsigned int abscnt[DP_DHCPV4_CODE_LEN];
} dp_dhcpv4_stats;

void dp_dhcpv4_check (
	dp_conf*,
	unsigned char*,
	int,
	int,
	unsigned char**,
	int*);

dp_dhcpv4_stats *dp_dhcpv4_cnt(uint8_t);

#endif // __DP_MACRO
