/**************************************************************************
* Copyright 2019 Pascal Gloor
* 
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
* 
*     http://www.apache.org/licenses/LICENSE-2.0
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
**************************************************************************/

#ifndef __DP_DHCPV6
#define __DP_DHCPV6 1

#include "dp_helpers.h"

static char *dp_dhcpv6_code[] = {
	NULL,
	"SOLICIT",
	"ADVERTISE",
	"REQUEST",
	"CONFIRM",
	"RENEW",
	"REBIND",
	"REPLY",
	"RELEASE",
	"DECLINE",
	"RECONFIGURE",
	"INFORMATION-REQUEST",
	"RELAY-FORW",
	"RELAY-REPL",
	"LEASEQUERY",
	"LEASEQUERY-REPLY",
	"LEASEQUERY-DONE",
	"LEASEQUERY-DATA",
	"RECONFIGURE-REQUEST",
	"RECONFIGURE-REPLY",
	"DHCPV4-QUERY",
	"DHCPV4-RESPONSE",
	"ACTIVELEASEQUERY",
	"STARTTLS",
	"BNDUPD",
	"BNDREPLY",
	"POOLREQ",
	"POOLRESP",
	"UPDREQ",
	"UPDREQALL",
	"UPDDONE",
	"CONNECT",
	"CONNECTREPLY",
	"DISCONNECT",
	"STATE",
	"CONTACT"
};

#define DP_DHCPV6_CODE_LEN (sizeof(dp_dhcpv6_code)/sizeof(dp_dhcpv6_code[0]))

typedef struct dp_dhcpv6_stats {
	long long unsigned int relcnt[DP_DHCPV6_CODE_LEN];
	long long unsigned int abscnt[DP_DHCPV6_CODE_LEN];
} dp_dhcpv6_stats;

void dp_dhcpv6_check (
	dp_conf*,
	unsigned char*,
	int,
	int,
	unsigned char**,
	int*);

dp_dhcpv6_stats *dp_dhcpv6_cnt(uint16_t);

#endif // __DP_MACRO
