/**************************************************************************
* Copyright 2019 Pascal Gloor
* 
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
* 
*     http://www.apache.org/licenses/LICENSE-2.0
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
**************************************************************************/

#ifndef __DP_HELPERS
#define __DP_HELPERS 1

#include <linux/limits.h>

typedef struct dp_conf {
	int pktint;
	int interval;
	int debug;
	int bltime;
	int queue;
	int dryrun;
	char stats_file[PATH_MAX];
	int stats_interval;
} dp_conf;


void       dp_usage               (char*);
dp_conf   *dp_load_config         (dp_conf*, char*);
void       dp_log              (unsigned char *, int, char *, ...);
char *dp_printid(unsigned char*, int);

#endif // __DP_MACRO
